<?php

/**
 * @Copyright Copyright (C) 2015 ... Ahmad Bilal
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * Company:     Buruj Solutions
  + Contact:    www.burujsolutions.com , ahmad@burujsolutions.com
 * Created on:  May 22, 2015
  ^
  + Project:    JS Tickets
  ^
 */
defined('_JEXEC') or die('Not Allowed');

class customfields {
    
    function formCustomFields($field , $obj_id, $obj_params , $isadmin ) { // $obj_id, $obj_params
        if($field->isuserfield != 1){
            return false;
        }
        $html = '';
        $flag = false;
        if($isadmin){
            $div1 = 'js-col-md-12';
            $div2 = 'js-col-xs-12 js-col-md-2 js-title';
            $div3 = 'js-col-xs-12 js-col-md-10 js-value';
        }else{
            if($field->size == 100){
                $div1 = 'js-col-md-12 js-col-xs-12';
                $div2 = 'js-form-title';
                $div3 = 'js-form-value';
            }elseif($field->size == 50){
                $div1 = 'js-col-md-6 js-col-xs-12';
                $div2 = 'js-form-title';
                $div3 = 'js-form-value';
            }
        }

        $required = $field->required;
        $cssclass = "";

        $html .= '<div class="' . $div1 . '">
               <div class="' . $div2 . '">';
        if ($required == 1) {
            $html .= $field->fieldtitle . '<font color="red">*</font>';
            if ($field->userfieldtype == 'email')
                $cssclass = "required validate-email";
            else
                $cssclass = "required";
        }else {
            $html .= $field->fieldtitle;
            if ($field->userfieldtype == 'email')
                $cssclass = "email";
            else
                $cssclass = "";
        }
        $html .= ' </div><div class="' . $div3 . '">';
        
       
        //$maxlength = $field->maxlength ? "'maxlength' => '" . $field->maxlength : "";
        $fvalue = "";
        $value = "";
        $userdataid = "";
        if (isset($obj_id)) {
            $userfielddataarray = json_decode($obj_params);
            $uffield = $field->field;
            if (isset($userfielddataarray->$uffield) || !empty($userfielddataarray->$uffield)) {
                $value = $userfielddataarray->$uffield;
            } else {
                $value = '';
            }
        }

        switch ($field->userfieldtype) {
            case 'text':
            case 'email':
                $html .= $this->text($field->field, $value, array('class' => "inputbox one $cssclass", 'data-validation' => $cssclass, 'size' => $field->size, 'maxlength' => $field->maxlength));
                break;
            case 'date':
                $html .= JHTML::_('calendar', $value, $field->field, $field->field, '%Y-%m-%d', array('class' => 'inputbox', 'size' => '10', 'maxlength' => '19'));
                break;
            case 'textarea':
                $html .= $this->textarea($field->field, $value, array('class' => "inputbox one $cssclass", 'data-validation' => $cssclass, 'rows' => $field->rows, 'cols' => $field->cols));
                break;
            case 'checkbox':
                if (!empty($field->userfieldparams)) {
                    $comboOptions = array();
                    $obj_option = json_decode($field->userfieldparams);
                    $i = 0;
                    $valuearray = explode(', ',$value);
                    foreach ($obj_option AS $option) {                        
                        $check = '';
                        if(in_array($option, $valuearray)){
                            $check = 'checked';
                        }
                        $html .= '<input type="checkbox" ' . $check . ' class="radiobutton" value="' . $option . '" id="' . $field->field . '_' . $i . '" name="' . $field->field . '[]">';
                        $html .= '<label for="' . $field->field . '_' . $i . '" id="foruf_checkbox1">' . $option . '</label>';
                        $i++;
                    }
                } else {
                    $comboOptions = array('1' => $field->fieldtitle);
                    $html .= $this->checkbox($field->field, $comboOptions, $value, array('class' => 'radiobutton'));
                }
                break;
            case 'radio':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    for ($i = 0; $i < count($obj_option); $i++) {
                        $comboOptions[$obj_option[$i]] = "$obj_option[$i]";
                    }
                }
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "',2);";
                }
                $html .= $this->radiobutton($field->field, $comboOptions, $value, array('data-validation' => $cssclass, 'onclick' => $jsFunction));
                break;
            case 'combo':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    foreach ($obj_option as $opt) {
                        $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                    }
                }
                //code for handling dependent field
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "',1);";
                }
                //end
                $html .= $this->select($field->field, $comboOptions, $value, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'onchange' => $jsFunction, 'class' => "inputbox one $cssclass"));
                break;
            case 'depandant_field':
                $comboOptions = array();
                if ($value != null) {
                    if (!empty($field->userfieldparams)) {
                        $obj_option = $this->getDataForDepandantFieldByParentField($field->field, $userfielddataarray);
                        foreach ($obj_option as $opt) {
                            $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                        }
                    }
                }
                //code for handling dependent field
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "');";
                }
                //end
                $html .= $this->select($field->field, $comboOptions, $value, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'onchange' => $jsFunction, 'class' => "inputbox one $cssclass"));
                break;
            case 'multiple':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    foreach ($obj_option as $opt) {
                        $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                    }
                }
                $array = $field->field;
                $array .= '[]';
                $valuearray = explode(', ', $value);
                $html .= $this->select($array, $comboOptions, $valuearray, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'multiple' => 'multiple', 'class' => "inputbox one $cssclass"));
                break;
            case 'file':
                $html .= '<input type="file" name="'.$field->field.'" id="'.$field->field.'"/>';
                $fileext = JSSupportTicketModel::getJSModel('config')->getConfigurationByName('fileextension');
                $html .= '<div id="js_cust_file_ext">'.JText::_('Files').'&nbsp;('.$fileext.')</div>';
                if($value != null){
                    $html .= $this->hidden($field->field.'_1', 0);
                    $html .= $this->hidden($field->field.'_2',$value);
                    $jsFunction = "deleteCutomUploadedFile('".$field->field."_1')";
                    $html .='<span class='.$field->field.'_1>'.$value.'( ';
                    $html .= "<a href='#' onClick=".$jsFunction." >". JText::_('Delete')."</a>";
                    $html .= ' )</span>';
                }
                break;
        }
        
        $html .= '</div></div>';


        echo $html;
    }

    function formCustomFieldsForSearch($field, &$col, $filter_params, $isadmin = 0) { // $filter_params
        if ($field->isuserfield != 1)
            return false;
        $cssclass = "";
        $html = '';
        $i = $col;
        $i++;
        $col++;
        $required = $field->required;
        $div1 = 'js-col-md-6 js-filter-wrapper';
        $div3 = 'js-col-md-12 js-filter-value js-margin-bottom-xs userfield';
        if($col % 2 == 0){
            if($col != 2){
                $html .= '</div>';
            }
            $html .= '<div class="js-col-md-12">';
        }
        $html .= '<div class="' . $div1 . '"> ';
        $html .= ' <div class="' . $div3 . '">';
        if($isadmin == 1){
            $html = ''; // only field send
        }
        $readonly = ''; //$field->readonly ? "'readonly => 'readonly'" : "";
        $maxlength = ''; //$field->maxlength ? "'maxlength' => '".$field->maxlength : "";
        $fvalue = "";
        $value = null;
        $userdataid = "";
        $userfielddataarray = array();
        if (isset($filter_params)) {
            $userfielddataarray = $filter_params;
            $uffield = $field->field;
            //had to user || oprator bcz of radio buttons

            if (isset($userfielddataarray[$uffield]) || !empty($userfielddataarray[$uffield])) {
                $value = $userfielddataarray[$uffield];
            } else {
                $value = '';
            }
        }
        switch ($field->userfieldtype) {
            case 'text':
            case 'email':
            case 'file':
                $html .= $this->text($field->field, $value, array('class' => "inputbox one $cssclass", 'data-validation' => $cssclass,'placeholder' =>$field->fieldtitle, 'size' => $field->size, 'maxlength' => $maxlength));
                break;
            case 'date':
                $html .= JHTML::_('calendar', $value, $field->field, $field->field, '%Y-%m-%d', array('class' => 'inputbox', 'size' => '10', 'maxlength' => '19'));
                break;
            case 'editor':
                $html .= wp_editor(isset($value) ? $value : '', $field->field, array('media_buttons' => false, 'data-validation' => $cssclass));
                break;
            case 'textarea':
                $html .= $this->textarea($field->field, $value, array('class' => "inputbox one $cssclass", 'data-validation' => $cssclass, 'rows' => $field->rows, 'cols' => $field->cols, $readonly));
                break;
            case 'checkbox':
                if (!empty($field->userfieldparams)) {
                    $comboOptions = array();
                    $obj_option = json_decode($field->userfieldparams);
                    if(empty($value))
                        $value = array();
                    foreach ($obj_option AS $option) {
                        if( in_array($option, $value)){
                            $check = 'checked="true"';
                        }else{
                            $check = '';
                        }
                        $html .= '<input type="checkbox" ' . $check . ' class="radiobutton" value="' . $option . '" id="' . $field->field . '_' . $i . '" name="' . $field->field . '[]">';
                        $html .= '<label for="' . $field->field . '_' . $i . '" id="foruf_checkbox1">' . $option . '</label>';
                        $i++;
                    }
                } else {
                    $comboOptions = array('1' => $field->fieldtitle);
                    $html .= $this->checkbox($field->field, $comboOptions, $value, array('class' => 'radiobutton'));
                }
                break;
            case 'radio':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    for ($i = 0; $i < count($obj_option); $i++) {
                        $comboOptions[$obj_option[$i]] = "$obj_option[$i]";
                    }
                }
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "',2);";
                }
                $html .= $this->radiobutton($field->field, $comboOptions, $value, array('class' => 'radiobutton' , 'data-validation' => $cssclass, "autocomplete" => "off", 'onclick' => $jsFunction));
                break;
            case 'combo':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    foreach ($obj_option as $opt) {
                        $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                    }
                }
                //code for handling dependent field
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "',1);";
                }
                //end
                $html .= $this->select($field->field, $comboOptions, $value, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'onchange' => $jsFunction, 'class' => "inputbox one $cssclass"));
                break;
            case 'depandant_field':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = $this->getDataForDepandantFieldByParentField($field->field, $userfielddataarray);
                    if (!empty($obj_option)) {
                        foreach ($obj_option as $opt) {
                            $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                        }
                    }
                }
                //code for handling dependent field
                $jsFunction = '';
                if ($field->depandant_field != null) {
                    $jsFunction = "getDataForDepandantField('" . $field->field . "','" . $field->depandant_field . "');";
                }
                //end
                $html .= $this->select($field->field, $comboOptions, $value, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'onchange' => $jsFunction, 'class' => "inputbox one $cssclass"));
                break;
            case 'multiple':
                $comboOptions = array();
                if (!empty($field->userfieldparams)) {
                    $obj_option = json_decode($field->userfieldparams);
                    foreach ($obj_option as $opt) {
                        $comboOptions[] = (object) array('id' => $opt, 'text' => $opt);
                    }
                }
                $array = $field->field;
                $array .= '[]';
                $html .= $this->select($array, $comboOptions, $value, JText::_('Select') . ' ' . $field->fieldtitle, array('data-validation' => $cssclass, 'multiple' => 'multiple'));
                break;
        }
        if($isadmin == 1){
            echo $html;
            return;
        }
        $html .= '</div></div>';
        echo $html;
        
    }

    function showCustomFields($field, $fieldfor, $params , $ticketid) { // ticketid
        $html = '';
        $fvalue = '';        
        
        if(!empty($params)){
            $data = json_decode($params,true);
            if(array_key_exists($field->field, $data)){
                $fvalue = $data[$field->field];
            }
        }
        if($fieldfor == 1){  //FrontEnd mytickets
            $html = '<div class="tk_mt_detail_desc_bottom">';
            if($field->userfieldtype=='file'){
            $html .= '<span class="tk_mt_detail_text">' . $field->fieldtitle . ':&nbsp</span>';
               if($fvalue !=null){
                    $path = "index.php?option=com_jssupportticket&c=ticket&task=downloadbyname&id=".$ticketid."&name=".$fvalue;
                    $html .= '
                        <div class="tk_mt_detail_value js_ticketattachment">
                            ' . $field->fieldtitle . ' ( ' . $fvalue . ' ) ' . '              
                            <a class="button" target="_blank" href="' . $path . '">' . JText::_('Download') . '</a>
                        </div>';
                }
            }else{
            $html .= '<span class="tk_mt_detail_text">' . $field->fieldtitle . ':&nbsp</span>';
                $html .= '<span class="tk_mt_detail_value">' . $fvalue . '</span>';
            }
            
                $html .= '</div>';
        }elseif($fieldfor == 2){ // ticket detail front end
            $html = '<div id="tk_detail_info_key_value_wraper" class="">';
            if($field->userfieldtype=='file'){
            $html .= '<span class="tk_detail_info_key">' . $field->fieldtitle . ':&nbsp</span>';
               if($fvalue != null){
                    $path = "index.php?option=com_jssupportticket&c=ticket&task=downloadbyname&id=".$ticketid."&name=".$fvalue;
                    $html .= '
                        <div class="tk_detail_info_value">
                            ' . $field->fieldtitle . ' ( ' . $fvalue . ' ) ' . '              
                            <a class="button" target="_blank" href="' . $path . '">' . JText::_('Download') . '</a>
                        </div>';
                }
            }else{
                $html .=    '<span class="tk_detail_info_key">' . $field->fieldtitle . ':&nbsp</span>
                        <span class="tk_detail_info_value">' . $fvalue . '</span>';
            }
            $html .=   '</div>';
        }elseif($fieldfor == 3){ // Admin ticket detail
            $html = '<div class="js-col-md-4">
                        <div class="requester-data-inner-border">
                            <div class="requester-data-inner-title js-col-xs-12">
                                <strong>' . $field->fieldtitle . '&nbsp;:</strong>
                            </div> ';
            $html .= '       <div class="requester-data-inner-value js-col-xs-12">' . $fvalue . '</div>
                        </div>
                    </div>';

            if($field->userfieldtype=='file'){
                $html = '<div class="js-col-md-4">
                            <div class="requester-data-inner-border">
                                <div class="requester-data-inner-title js-col-xs-12">
                                    <strong>' . $field->fieldtitle. '&nbsp;:</strong>
                                </div> ';
                if($fvalue !=null){
                    $path = "index.php?option=com_jssupportticket&c=ticket&task=downloadbyname&id=".$ticketid."&name=".$fvalue;
                    $html .= '<div class="requester-data-inner-value js-col-xs-12">' . $field->fieldtitle . ' ( ' . $fvalue . ' ) ' . '<a class="button" target="_blank" href="' . $path . '">' . JText::_('Download') . '</a></div>
                                </div>
                            </div>';
                }
            }
        }elseif($fieldfor == 4){ // admin ticket listing
            $html = '<div class="js-col-md-12 js-col-xs-12 js-wrapper">';
            if($field->userfieldtype=='file'){
            $html .= '<span class="js-tk-title">' . $field->fieldtitle . '<font>:</font>&nbsp;</span>';
               if($fvalue !=null){
                    $path = "index.php?option=com_jssupportticket&c=ticket&task=downloadbyname&id=".$ticketid."&name=".$fvalue;
                    $html .= '
                        <div class="js-tk-value js_ticketattachment">
                            ' . $field->fieldtitle . ' ( ' . $fvalue . ' ) ' . '              
                            <a class="button" target="_blank" href="' . $path . '">' . JText::_('Download') . '</a>
                        </div>';
                }
            }else{
            $html .= '<span class="js-tk-title">' . $field->fieldtitle . ':&nbsp</span>';
                $html .= '<span class="js-tk-value">' . $fvalue . '</span>';
            }
            
                $html .= '</div>';
        }

        return $html;
    }

    function userFieldsData($fieldfor, $listing = null) {
        $db = JFactory::getDbo();
        $user = JSSupportticketCurrentUser::getInstance();
        if ($user->getIsGuest()) {
            $published = ' isvisitorpublished = 1 ';
        } else {
            $published = ' published = 1 ';
        }
        $inquery = '';
        if ($listing == 1) {
            $inquery = ' AND showonlisting = 1 ';
        }
        $query = "SELECT field,fieldtitle,isuserfield,userfieldtype,userfieldparams  FROM `#__js_ticket_fieldsordering` WHERE isuserfield = 1 AND " . $published . " AND fieldfor =" . $fieldfor . $inquery." ORDER BY ordering";
        $db->setQuery($query);
        $data = $db->loadObjectList();
        return $data;
    }

    function userFieldsForSearch($fieldfor) {
        $db = JFactory::getDbo();
        $user = JSSupportticketCurrentUser::getInstance();
        if ($user->getIsGuest()) {
            $inquery = ' isvisitorpublished = 1 AND search_visitor =1';
        } else {
            $inquery = ' published = 1 AND search_user =1';
        }
        $query = "SELECT required,cols,size ,rows,field,fieldtitle,isuserfield,userfieldtype,userfieldparams,depandant_field  FROM `#__js_ticket_fieldsordering` WHERE isuserfield = 1 AND " . $inquery . " AND fieldfor =" . $fieldfor ." ORDER BY ordering ";
        $db->setQuery($query);
        $data = $db->loadObjectList();
        return $data;
    }

    function getDataForDepandantFieldByParentField($fieldfor, $data) {
        $user = JSSupportticketCurrentUser::getInstance();
        if ($user->getIsGuest()) {
            $published = ' isvisitorpublished = 1 ';
        } else {
            $published = ' published = 1 ';
        }
        $db = JFactory::getDbo();
        $value = '';
        $returnarray = array();
        $query = "SELECT field from `#__js_ticket_fieldsordering` WHERE isuserfield = 1 AND " . $published . " AND depandant_field ='" . $fieldfor . "'";
        $db->setQuery($query);
        $field = $db->loadResult();
        if ($data != null) {
            foreach ($data as $key => $val) {
                if ($key == $field) {
                    $value = $val;
                }
            }
        }
        $query = "SELECT userfieldparams from `#__js_ticket_fieldsordering` WHERE isuserfield = 1 AND " . $published . " AND field ='" . $fieldfor . "'";
        $db->setQuery($query);
        $field = $db->loadResult();
        $fieldarray = json_decode($field);
        foreach ($fieldarray as $key => $val) {
            if ($value == $key)
                $returnarray = $val;
        }
        return $returnarray;
    }
    // new
    private function text($name, $value, $extraattr = array()) {
        $textfield = '<input type="text" name="' . $name . '" id="' . $name . '" value="' . $value . '" ';
        if (!empty($extraattr))
            foreach ($extraattr AS $key => $val)
                $textfield .= ' ' . $key . '="' . $val . '"';
        $textfield .= ' />';
        return $textfield;
    }
    private function textarea($name, $value, $extraattr = array()) {
        $textarea = '<textarea name="' . $name . '" id="' . $name . '" ';
        if (!empty($extraattr))
            foreach ($extraattr AS $key => $val)
                $textarea .= ' ' . $key . '="' . $val . '"';
        $textarea .= ' >' . $value . '</textarea>';
        return $textarea;
    }
    private function hidden($name, $value, $extraattr = array()) {
        $textfield = '<input type="hidden" name="' . $name . '" id="' . $name . '" value="' . $value . '" ';
        if (!empty($extraattr))
            foreach ($extraattr AS $key => $val)
                $textfield .= ' ' . $key . '="' . $val . '"';
        $textfield .= ' />';
        return $textfield;
    }
    private function select($name, $list, $defaultvalue, $title = '', $extraattr = array()) {
		$nameid = str_replace('[]','',$name);
        $selectfield = '<select name="' . $name . '" id="' . $nameid . '" ';
        if (!empty($extraattr))
            foreach ($extraattr AS $key => $val) {
                $selectfield .= ' ' . $key . '="' . $val . '"';
            }
        $selectfield .= ' >';
        if ($title != '') {
            $selectfield .= '<option value="">' . $title . '</option>';
        }
        if (!empty($list))
            foreach ($list AS $record) {
                if ((is_array($defaultvalue) && in_array($record->id, $defaultvalue)) || $defaultvalue == $record->id)
                    $selectfield .= '<option selected="selected" value="' . $record->id . '">' . JText::_($record->text,'js-support-ticket') . '</option>';
                else
                    $selectfield .= '<option value="' . $record->id . '">' . JText::_($record->text,'js-support-ticket') . '</option>';
            }

        $selectfield .= '</select>';
        return $selectfield;
    }
    private function radiobutton($name, $list, $defaultvalue, $extraattr = array()) {
        $radiobutton = '';
        $count = 1;
        foreach ($list AS $value => $label) {
            $radiobutton .= '<input type="radio" name="' . $name . '" id="' . $name . $count . '" value="' . $value . '"';
            if ($defaultvalue == $value)
                $radiobutton .= ' checked="checked"';
            if (!empty($extraattr))
                foreach ($extraattr AS $key => $val) {
                    $radiobutton .= ' ' . $key . '="' . $val . '"';
                }
            $radiobutton .= '/><label id="for' . $name . '" for="' . $name . $count . '">' . $label . '</label>';
            $count++;
        }
        return $radiobutton;
    }
    private function checkbox($name, $list, $defaultvalue, $extraattr = array()) {
        $checkbox = '';
        $count = 1;
        foreach ($list AS $value => $label) {
            $checkbox .= '<input type="checkbox" name="' . $name . '" id="' . $name . $count . '" value="' . $value . '"';
            if ($defaultvalue == $value)
                $checkbox .= ' checked="checked"';
            if (!empty($extraattr))
                foreach ($extraattr AS $key => $val) {
                    $checkbox .= ' ' . $key . '="' . $val . '"';
                }
            $checkbox .= '/><label id="for' . $name . '" for="' . $name . $count . '">' . $label . '</label>';
            $count++;
        }
        return $checkbox;
    }    
}
?>
